/* eslint-disable */
'use strict';

var path = require('path');
var pluginutils = require('@rollup/pluginutils');
var require$$0$1 = require('util');
var require$$0 = require('os');
var semver = require('semver');
var fs = require('fs-extra');
var _ = require('lodash');
var fs$1 = require('fs');

function _interopNamespaceDefault(e) {
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var path__namespace = /*#__PURE__*/_interopNamespaceDefault(path);
var fs__namespace = /*#__PURE__*/_interopNamespaceDefault(fs);
var ___namespace = /*#__PURE__*/_interopNamespaceDefault(_);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */


function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

var safe = {exports: {}};

var colors = {exports: {}};

var styles = {exports: {}};

/*
The MIT License (MIT)

Copyright (c) Sindre Sorhus <sindresorhus@gmail.com> (sindresorhus.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/

(function (module) {
	var styles = {};
	module['exports'] = styles;

	var codes = {
	  reset: [0, 0],

	  bold: [1, 22],
	  dim: [2, 22],
	  italic: [3, 23],
	  underline: [4, 24],
	  inverse: [7, 27],
	  hidden: [8, 28],
	  strikethrough: [9, 29],

	  black: [30, 39],
	  red: [31, 39],
	  green: [32, 39],
	  yellow: [33, 39],
	  blue: [34, 39],
	  magenta: [35, 39],
	  cyan: [36, 39],
	  white: [37, 39],
	  gray: [90, 39],
	  grey: [90, 39],

	  brightRed: [91, 39],
	  brightGreen: [92, 39],
	  brightYellow: [93, 39],
	  brightBlue: [94, 39],
	  brightMagenta: [95, 39],
	  brightCyan: [96, 39],
	  brightWhite: [97, 39],

	  bgBlack: [40, 49],
	  bgRed: [41, 49],
	  bgGreen: [42, 49],
	  bgYellow: [43, 49],
	  bgBlue: [44, 49],
	  bgMagenta: [45, 49],
	  bgCyan: [46, 49],
	  bgWhite: [47, 49],
	  bgGray: [100, 49],
	  bgGrey: [100, 49],

	  bgBrightRed: [101, 49],
	  bgBrightGreen: [102, 49],
	  bgBrightYellow: [103, 49],
	  bgBrightBlue: [104, 49],
	  bgBrightMagenta: [105, 49],
	  bgBrightCyan: [106, 49],
	  bgBrightWhite: [107, 49],

	  // legacy styles for colors pre v1.0.0
	  blackBG: [40, 49],
	  redBG: [41, 49],
	  greenBG: [42, 49],
	  yellowBG: [43, 49],
	  blueBG: [44, 49],
	  magentaBG: [45, 49],
	  cyanBG: [46, 49],
	  whiteBG: [47, 49],

	};

	Object.keys(codes).forEach(function(key) {
	  var val = codes[key];
	  var style = styles[key] = [];
	  style.open = '\u001b[' + val[0] + 'm';
	  style.close = '\u001b[' + val[1] + 'm';
	}); 
} (styles));

var stylesExports = styles.exports;

/*
MIT License

Copyright (c) Sindre Sorhus <sindresorhus@gmail.com> (sindresorhus.com)

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

var hasFlag$1 = function(flag, argv) {
  argv = argv || process.argv;

  var terminatorPos = argv.indexOf('--');
  var prefix = /^-{1,2}/.test(flag) ? '' : '--';
  var pos = argv.indexOf(prefix + flag);

  return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
};

/*
The MIT License (MIT)

Copyright (c) Sindre Sorhus <sindresorhus@gmail.com> (sindresorhus.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/

var os = require$$0;
var hasFlag = hasFlag$1;

var env = process.env;

var forceColor = void 0;
if (hasFlag('no-color') || hasFlag('no-colors') || hasFlag('color=false')) {
  forceColor = false;
} else if (hasFlag('color') || hasFlag('colors') || hasFlag('color=true')
           || hasFlag('color=always')) {
  forceColor = true;
}
if ('FORCE_COLOR' in env) {
  forceColor = env.FORCE_COLOR.length === 0
    || parseInt(env.FORCE_COLOR, 10) !== 0;
}

function translateLevel(level) {
  if (level === 0) {
    return false;
  }

  return {
    level: level,
    hasBasic: true,
    has256: level >= 2,
    has16m: level >= 3,
  };
}

function supportsColor(stream) {
  if (forceColor === false) {
    return 0;
  }

  if (hasFlag('color=16m') || hasFlag('color=full')
      || hasFlag('color=truecolor')) {
    return 3;
  }

  if (hasFlag('color=256')) {
    return 2;
  }

  if (stream && !stream.isTTY && forceColor !== true) {
    return 0;
  }

  var min = forceColor ? 1 : 0;

  if (process.platform === 'win32') {
    // Node.js 7.5.0 is the first version of Node.js to include a patch to
    // libuv that enables 256 color output on Windows. Anything earlier and it
    // won't work. However, here we target Node.js 8 at minimum as it is an LTS
    // release, and Node.js 7 is not. Windows 10 build 10586 is the first
    // Windows release that supports 256 colors. Windows 10 build 14931 is the
    // first release that supports 16m/TrueColor.
    var osRelease = os.release().split('.');
    if (Number(process.versions.node.split('.')[0]) >= 8
        && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
      return Number(osRelease[2]) >= 14931 ? 3 : 2;
    }

    return 1;
  }

  if ('CI' in env) {
    if (['TRAVIS', 'CIRCLECI', 'APPVEYOR', 'GITLAB_CI'].some(function(sign) {
      return sign in env;
    }) || env.CI_NAME === 'codeship') {
      return 1;
    }

    return min;
  }

  if ('TEAMCITY_VERSION' in env) {
    return (/^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0
    );
  }

  if ('TERM_PROGRAM' in env) {
    var version = parseInt((env.TERM_PROGRAM_VERSION || '').split('.')[0], 10);

    switch (env.TERM_PROGRAM) {
      case 'iTerm.app':
        return version >= 3 ? 3 : 2;
      case 'Hyper':
        return 3;
      case 'Apple_Terminal':
        return 2;
      // No default
    }
  }

  if (/-256(color)?$/i.test(env.TERM)) {
    return 2;
  }

  if (/^screen|^xterm|^vt100|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
    return 1;
  }

  if ('COLORTERM' in env) {
    return 1;
  }

  if (env.TERM === 'dumb') {
    return min;
  }

  return min;
}

function getSupportLevel(stream) {
  var level = supportsColor(stream);
  return translateLevel(level);
}

var supportsColors = {
  supportsColor: getSupportLevel,
  stdout: getSupportLevel(process.stdout),
  stderr: getSupportLevel(process.stderr),
};

var trap = {exports: {}};

var hasRequiredTrap;

function requireTrap () {
	if (hasRequiredTrap) return trap.exports;
	hasRequiredTrap = 1;
	(function (module) {
		module['exports'] = function runTheTrap(text, options) {
		  var result = '';
		  text = text || 'Run the trap, drop the bass';
		  text = text.split('');
		  var trap = {
		    a: ['\u0040', '\u0104', '\u023a', '\u0245', '\u0394', '\u039b', '\u0414'],
		    b: ['\u00df', '\u0181', '\u0243', '\u026e', '\u03b2', '\u0e3f'],
		    c: ['\u00a9', '\u023b', '\u03fe'],
		    d: ['\u00d0', '\u018a', '\u0500', '\u0501', '\u0502', '\u0503'],
		    e: ['\u00cb', '\u0115', '\u018e', '\u0258', '\u03a3', '\u03be', '\u04bc',
		      '\u0a6c'],
		    f: ['\u04fa'],
		    g: ['\u0262'],
		    h: ['\u0126', '\u0195', '\u04a2', '\u04ba', '\u04c7', '\u050a'],
		    i: ['\u0f0f'],
		    j: ['\u0134'],
		    k: ['\u0138', '\u04a0', '\u04c3', '\u051e'],
		    l: ['\u0139'],
		    m: ['\u028d', '\u04cd', '\u04ce', '\u0520', '\u0521', '\u0d69'],
		    n: ['\u00d1', '\u014b', '\u019d', '\u0376', '\u03a0', '\u048a'],
		    o: ['\u00d8', '\u00f5', '\u00f8', '\u01fe', '\u0298', '\u047a', '\u05dd',
		      '\u06dd', '\u0e4f'],
		    p: ['\u01f7', '\u048e'],
		    q: ['\u09cd'],
		    r: ['\u00ae', '\u01a6', '\u0210', '\u024c', '\u0280', '\u042f'],
		    s: ['\u00a7', '\u03de', '\u03df', '\u03e8'],
		    t: ['\u0141', '\u0166', '\u0373'],
		    u: ['\u01b1', '\u054d'],
		    v: ['\u05d8'],
		    w: ['\u0428', '\u0460', '\u047c', '\u0d70'],
		    x: ['\u04b2', '\u04fe', '\u04fc', '\u04fd'],
		    y: ['\u00a5', '\u04b0', '\u04cb'],
		    z: ['\u01b5', '\u0240'],
		  };
		  text.forEach(function(c) {
		    c = c.toLowerCase();
		    var chars = trap[c] || [' '];
		    var rand = Math.floor(Math.random() * chars.length);
		    if (typeof trap[c] !== 'undefined') {
		      result += trap[c][rand];
		    } else {
		      result += c;
		    }
		  });
		  return result;
		}; 
	} (trap));
	return trap.exports;
}

var zalgo = {exports: {}};

var hasRequiredZalgo;

function requireZalgo () {
	if (hasRequiredZalgo) return zalgo.exports;
	hasRequiredZalgo = 1;
	(function (module) {
		// please no
		module['exports'] = function zalgo(text, options) {
		  text = text || '   he is here   ';
		  var soul = {
		    'up': [
		      '̍', '̎', '̄', '̅',
		      '̿', '̑', '̆', '̐',
		      '͒', '͗', '͑', '̇',
		      '̈', '̊', '͂', '̓',
		      '̈', '͊', '͋', '͌',
		      '̃', '̂', '̌', '͐',
		      '̀', '́', '̋', '̏',
		      '̒', '̓', '̔', '̽',
		      '̉', 'ͣ', 'ͤ', 'ͥ',
		      'ͦ', 'ͧ', 'ͨ', 'ͩ',
		      'ͪ', 'ͫ', 'ͬ', 'ͭ',
		      'ͮ', 'ͯ', '̾', '͛',
		      '͆', '̚',
		    ],
		    'down': [
		      '̖', '̗', '̘', '̙',
		      '̜', '̝', '̞', '̟',
		      '̠', '̤', '̥', '̦',
		      '̩', '̪', '̫', '̬',
		      '̭', '̮', '̯', '̰',
		      '̱', '̲', '̳', '̹',
		      '̺', '̻', '̼', 'ͅ',
		      '͇', '͈', '͉', '͍',
		      '͎', '͓', '͔', '͕',
		      '͖', '͙', '͚', '̣',
		    ],
		    'mid': [
		      '̕', '̛', '̀', '́',
		      '͘', '̡', '̢', '̧',
		      '̨', '̴', '̵', '̶',
		      '͜', '͝', '͞',
		      '͟', '͠', '͢', '̸',
		      '̷', '͡', ' ҉',
		    ],
		  };
		  var all = [].concat(soul.up, soul.down, soul.mid);

		  function randomNumber(range) {
		    var r = Math.floor(Math.random() * range);
		    return r;
		  }

		  function isChar(character) {
		    var bool = false;
		    all.filter(function(i) {
		      bool = (i === character);
		    });
		    return bool;
		  }


		  function heComes(text, options) {
		    var result = '';
		    var counts;
		    var l;
		    options = options || {};
		    options['up'] =
		      typeof options['up'] !== 'undefined' ? options['up'] : true;
		    options['mid'] =
		      typeof options['mid'] !== 'undefined' ? options['mid'] : true;
		    options['down'] =
		      typeof options['down'] !== 'undefined' ? options['down'] : true;
		    options['size'] =
		      typeof options['size'] !== 'undefined' ? options['size'] : 'maxi';
		    text = text.split('');
		    for (l in text) {
		      if (isChar(l)) {
		        continue;
		      }
		      result = result + text[l];
		      counts = {'up': 0, 'down': 0, 'mid': 0};
		      switch (options.size) {
		        case 'mini':
		          counts.up = randomNumber(8);
		          counts.mid = randomNumber(2);
		          counts.down = randomNumber(8);
		          break;
		        case 'maxi':
		          counts.up = randomNumber(16) + 3;
		          counts.mid = randomNumber(4) + 1;
		          counts.down = randomNumber(64) + 3;
		          break;
		        default:
		          counts.up = randomNumber(8) + 1;
		          counts.mid = randomNumber(6) / 2;
		          counts.down = randomNumber(8) + 1;
		          break;
		      }

		      var arr = ['up', 'mid', 'down'];
		      for (var d in arr) {
		        var index = arr[d];
		        for (var i = 0; i <= counts[index]; i++) {
		          if (options[index]) {
		            result = result + soul[index][randomNumber(soul[index].length)];
		          }
		        }
		      }
		    }
		    return result;
		  }
		  // don't summon him
		  return heComes(text, options);
		}; 
	} (zalgo));
	return zalgo.exports;
}

var america = {exports: {}};

var hasRequiredAmerica;

function requireAmerica () {
	if (hasRequiredAmerica) return america.exports;
	hasRequiredAmerica = 1;
	(function (module) {
		module['exports'] = function(colors) {
		  return function(letter, i, exploded) {
		    if (letter === ' ') return letter;
		    switch (i%3) {
		      case 0: return colors.red(letter);
		      case 1: return colors.white(letter);
		      case 2: return colors.blue(letter);
		    }
		  };
		}; 
	} (america));
	return america.exports;
}

var zebra = {exports: {}};

var hasRequiredZebra;

function requireZebra () {
	if (hasRequiredZebra) return zebra.exports;
	hasRequiredZebra = 1;
	(function (module) {
		module['exports'] = function(colors) {
		  return function(letter, i, exploded) {
		    return i % 2 === 0 ? letter : colors.inverse(letter);
		  };
		}; 
	} (zebra));
	return zebra.exports;
}

var rainbow = {exports: {}};

var hasRequiredRainbow;

function requireRainbow () {
	if (hasRequiredRainbow) return rainbow.exports;
	hasRequiredRainbow = 1;
	(function (module) {
		module['exports'] = function(colors) {
		  // RoY G BiV
		  var rainbowColors = ['red', 'yellow', 'green', 'blue', 'magenta'];
		  return function(letter, i, exploded) {
		    if (letter === ' ') {
		      return letter;
		    } else {
		      return colors[rainbowColors[i++ % rainbowColors.length]](letter);
		    }
		  };
		}; 
	} (rainbow));
	return rainbow.exports;
}

var random = {exports: {}};

var hasRequiredRandom;

function requireRandom () {
	if (hasRequiredRandom) return random.exports;
	hasRequiredRandom = 1;
	(function (module) {
		module['exports'] = function(colors) {
		  var available = ['underline', 'inverse', 'grey', 'yellow', 'red', 'green',
		    'blue', 'white', 'cyan', 'magenta', 'brightYellow', 'brightRed',
		    'brightGreen', 'brightBlue', 'brightWhite', 'brightCyan', 'brightMagenta'];
		  return function(letter, i, exploded) {
		    return letter === ' ' ? letter :
		      colors[
		          available[Math.round(Math.random() * (available.length - 2))]
		      ](letter);
		  };
		}; 
	} (random));
	return random.exports;
}

/*

The MIT License (MIT)

Original Library
  - Copyright (c) Marak Squires

Additional functionality
 - Copyright (c) Sindre Sorhus <sindresorhus@gmail.com> (sindresorhus.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/

(function (module) {
	var colors = {};
	module['exports'] = colors;

	colors.themes = {};

	var util = require$$0$1;
	var ansiStyles = colors.styles = stylesExports;
	var defineProps = Object.defineProperties;
	var newLineRegex = new RegExp(/[\r\n]+/g);

	colors.supportsColor = supportsColors.supportsColor;

	if (typeof colors.enabled === 'undefined') {
	  colors.enabled = colors.supportsColor() !== false;
	}

	colors.enable = function() {
	  colors.enabled = true;
	};

	colors.disable = function() {
	  colors.enabled = false;
	};

	colors.stripColors = colors.strip = function(str) {
	  return ('' + str).replace(/\x1B\[\d+m/g, '');
	};

	// eslint-disable-next-line no-unused-vars
	colors.stylize = function stylize(str, style) {
	  if (!colors.enabled) {
	    return str+'';
	  }

	  var styleMap = ansiStyles[style];

	  // Stylize should work for non-ANSI styles, too
	  if(!styleMap && style in colors){
	    // Style maps like trap operate as functions on strings;
	    // they don't have properties like open or close.
	    return colors[style](str);
	  }

	  return styleMap.open + str + styleMap.close;
	};

	var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
	var escapeStringRegexp = function(str) {
	  if (typeof str !== 'string') {
	    throw new TypeError('Expected a string');
	  }
	  return str.replace(matchOperatorsRe, '\\$&');
	};

	function build(_styles) {
	  var builder = function builder() {
	    return applyStyle.apply(builder, arguments);
	  };
	  builder._styles = _styles;
	  // __proto__ is used because we must return a function, but there is
	  // no way to create a function with a different prototype.
	  Object.setPrototypeOf(builder, proto);
	  return builder;
	}

	var styles = (function() {
	  var ret = {};
	  ansiStyles.grey = ansiStyles.gray;
	  Object.keys(ansiStyles).forEach(function(key) {
	    ansiStyles[key].closeRe =
	      new RegExp(escapeStringRegexp(ansiStyles[key].close), 'g');
	    ret[key] = {
	      get: function() {
	        return build(this._styles.concat(key));
	      },
	    };
	  });
	  return ret;
	})();

	var proto = defineProps(function colors() {}, styles);

	function applyStyle() {
	  var args = Array.prototype.slice.call(arguments);

	  var str = args.map(function(arg) {
	    // Use weak equality check so we can colorize null/undefined in safe mode
	    if (arg != null && arg.constructor === String) {
	      return arg;
	    } else {
	      return util.inspect(arg);
	    }
	  }).join(' ');

	  if (!colors.enabled || !str) {
	    return str;
	  }

	  var newLinesPresent = str.indexOf('\n') != -1;

	  var nestedStyles = this._styles;

	  var i = nestedStyles.length;
	  while (i--) {
	    var code = ansiStyles[nestedStyles[i]];
	    str = code.open + str.replace(code.closeRe, code.open) + code.close;
	    if (newLinesPresent) {
	      str = str.replace(newLineRegex, function(match) {
	        return code.close + match + code.open;
	      });
	    }
	  }

	  return str;
	}

	colors.setTheme = function(theme) {
	  if (typeof theme === 'string') {
	    console.log('colors.setTheme now only accepts an object, not a string.  ' +
	      'If you are trying to set a theme from a file, it is now your (the ' +
	      'caller\'s) responsibility to require the file.  The old syntax ' +
	      'looked like colors.setTheme(__dirname + ' +
	      '\'/../themes/generic-logging.js\'); The new syntax looks like '+
	      'colors.setTheme(require(__dirname + ' +
	      '\'/../themes/generic-logging.js\'));');
	    return;
	  }
	  for (var style in theme) {
	    (function(style) {
	      colors[style] = function(str) {
	        if (typeof theme[style] === 'object') {
	          var out = str;
	          for (var i in theme[style]) {
	            out = colors[theme[style][i]](out);
	          }
	          return out;
	        }
	        return colors[theme[style]](str);
	      };
	    })(style);
	  }
	};

	function init() {
	  var ret = {};
	  Object.keys(styles).forEach(function(name) {
	    ret[name] = {
	      get: function() {
	        return build([name]);
	      },
	    };
	  });
	  return ret;
	}

	var sequencer = function sequencer(map, str) {
	  var exploded = str.split('');
	  exploded = exploded.map(map);
	  return exploded.join('');
	};

	// custom formatter methods
	colors.trap = requireTrap();
	colors.zalgo = requireZalgo();

	// maps
	colors.maps = {};
	colors.maps.america = requireAmerica()(colors);
	colors.maps.zebra = requireZebra()(colors);
	colors.maps.rainbow = requireRainbow()(colors);
	colors.maps.random = requireRandom()(colors);

	for (var map in colors.maps) {
	  (function(map) {
	    colors[map] = function(str) {
	      return sequencer(colors.maps[map], str);
	    };
	  })(map);
	}

	defineProps(colors, init()); 
} (colors));

var colorsExports = colors.exports;

(function (module) {
	//
	// Remark: Requiring this file will use the "safe" colors API,
	// which will not touch String.prototype.
	//
	//   var colors = require('colors/safe');
	//   colors.red("foo")
	//
	//
	var colors = colorsExports;
	module['exports'] = colors; 
} (safe));

var safeExports = safe.exports;

var VerbosityLevel;
(function (VerbosityLevel) {
    VerbosityLevel[VerbosityLevel["Error"] = 0] = "Error";
    VerbosityLevel[VerbosityLevel["Warning"] = 1] = "Warning";
    VerbosityLevel[VerbosityLevel["Info"] = 2] = "Info";
    VerbosityLevel[VerbosityLevel["Debug"] = 3] = "Debug";
})(VerbosityLevel || (VerbosityLevel = {}));
function getText(message) {
    return typeof message === "string" ? message : message();
}
/** cannot be used in options hook (which does not have this.warn and this.error), but can be in other hooks */
class RollupContext {
    constructor(verbosity, bail, context, prefix = "") {
        this.verbosity = verbosity;
        this.bail = bail;
        this.context = context;
        this.prefix = prefix;
    }
    warn(message) {
        if (this.verbosity < VerbosityLevel.Warning)
            return;
        this.context.warn(`${getText(message)}`);
    }
    error(message) {
        if (this.verbosity < VerbosityLevel.Error)
            return;
        if (this.bail)
            this.context.error(`${getText(message)}`);
        else
            this.context.warn(`${getText(message)}`);
    }
    info(message) {
        if (this.verbosity < VerbosityLevel.Info)
            return;
        console.log(`${this.prefix}${getText(message)}`);
    }
    debug(message) {
        if (this.verbosity < VerbosityLevel.Debug)
            return;
        console.log(`${this.prefix}${getText(message)}`);
    }
}

let tsModule;
function setTypescriptModule(override) {
    tsModule = override;
}

class LanguageServiceHost {
    constructor(parsedConfig, transformers, cwd) {
        this.parsedConfig = parsedConfig;
        this.transformers = transformers;
        this.cwd = cwd;
        this.snapshots = {};
        this.versions = {};
        this.getScriptFileNames = () => Array.from(this.fileNames.values());
        this.getCompilationSettings = () => this.parsedConfig.options;
        this.getTypeRootsVersion = () => 0;
        this.getCurrentDirectory = () => this.cwd;
        this.useCaseSensitiveFileNames = () => tsModule.sys.useCaseSensitiveFileNames;
        this.getDefaultLibFileName = tsModule.getDefaultLibFilePath; // confusing naming: https://github.com/microsoft/TypeScript/issues/35318
        this.readDirectory = tsModule.sys.readDirectory;
        this.readFile = tsModule.sys.readFile;
        this.fileExists = tsModule.sys.fileExists;
        this.directoryExists = tsModule.sys.directoryExists;
        this.getDirectories = tsModule.sys.getDirectories;
        this.realpath = tsModule.sys.realpath; // this exists in the default implementation: https://github.com/microsoft/TypeScript/blob/ab2523bbe0352d4486f67b73473d2143ad64d03d/src/compiler/sys.ts#L1288
        this.trace = console.log;
        this.fileNames = new Set(parsedConfig.fileNames);
    }
    reset() {
        this.snapshots = {};
        this.versions = {};
    }
    setLanguageService(service) {
        this.service = service;
    }
    setSnapshot(fileName, source) {
        fileName = pluginutils.normalizePath(fileName);
        const snapshot = tsModule.ScriptSnapshot.fromString(source);
        this.snapshots[fileName] = snapshot;
        this.versions[fileName] = (this.versions[fileName] || 0) + 1;
        this.fileNames.add(fileName);
        return snapshot;
    }
    getScriptSnapshot(fileName) {
        fileName = pluginutils.normalizePath(fileName);
        if (fileName in this.snapshots)
            return this.snapshots[fileName];
        const source = tsModule.sys.readFile(fileName);
        if (source)
            return this.setSnapshot(fileName, source);
        return undefined;
    }
    getScriptVersion(fileName) {
        fileName = pluginutils.normalizePath(fileName);
        return (this.versions[fileName] || 0).toString();
    }
    getCustomTransformers() {
        if (this.service === undefined || this.transformers === undefined || this.transformers.length === 0)
            return undefined;
        const transformer = {
            before: [],
            after: [],
            afterDeclarations: [],
        };
        for (const creator of this.transformers) {
            const factory = creator(this.service);
            if (factory.before)
                transformer.before = transformer.before.concat(factory.before);
            if (factory.after)
                transformer.after = transformer.after.concat(factory.after);
            if (factory.afterDeclarations)
                transformer.afterDeclarations = transformer.afterDeclarations.concat(factory.afterDeclarations);
        }
        return transformer;
    }
}

/**
 * Saves data in new cache folder or reads it from old one.
 * Avoids perpetually growing cache and situations when things need to consider changed and then reverted data to be changed.
 */
class RollingCache {
    /** @param cacheRoot: root folder for the cache */
    constructor(cacheRoot) {
        this.cacheRoot = cacheRoot;
        this.rolled = false;
        this.oldCacheRoot = `${this.cacheRoot}/cache`;
        this.newCacheRoot = `${this.cacheRoot}/cache_`;
        fs.emptyDirSync(this.newCacheRoot);
    }
    /** @returns true if name exists in either old cache or new cache */
    exists(name) {
        if (this.rolled)
            return false;
        if (fs$1.existsSync(`${this.newCacheRoot}/${name}`))
            return true;
        return fs$1.existsSync(`${this.oldCacheRoot}/${name}`);
    }
    path(name) {
        return `${this.oldCacheRoot}/${name}`;
    }
    /** @returns true if old cache contains all names and nothing more */
    match(names) {
        if (this.rolled)
            return false;
        if (!fs$1.existsSync(this.oldCacheRoot))
            return names.length === 0; // empty folder matches
        return ___namespace.isEqual(fs$1.readdirSync(this.oldCacheRoot).sort(), names.sort());
    }
    /** @returns data for name, must exist in either old cache or new cache */
    read(name) {
        if (fs$1.existsSync(`${this.newCacheRoot}/${name}`))
            return fs.readJsonSync(`${this.newCacheRoot}/${name}`, { encoding: "utf8", throws: false });
        return fs.readJsonSync(`${this.oldCacheRoot}/${name}`, { encoding: "utf8", throws: false });
    }
    write(name, data) {
        if (this.rolled)
            return;
        if (data === undefined)
            return;
        fs.writeJsonSync(`${this.newCacheRoot}/${name}`, data);
    }
    touch(name) {
        if (this.rolled)
            return;
        fs.ensureFileSync(`${this.newCacheRoot}/${name}`);
    }
    /** clears old cache and moves new in its place */
    roll() {
        if (this.rolled)
            return;
        this.rolled = true;
        fs.removeSync(this.oldCacheRoot);
        if (fs$1.existsSync(this.newCacheRoot)) {
            fs$1.renameSync(this.newCacheRoot, this.oldCacheRoot);
        }
    }
}

class FormatHost {
    constructor() {
        this.getCanonicalFileName = path__namespace.normalize;
        this.getNewLine = () => tsModule.sys.newLine;
    }
    getCurrentDirectory() {
        return tsModule.sys.getCurrentDirectory();
    }
}
const formatHost = new FormatHost();

function convertDiagnostic(type, data) {
    return data.map((diagnostic) => {
        const entry = {
            flatMessage: tsModule.flattenDiagnosticMessageText(diagnostic.messageText, formatHost.getNewLine()),
            formatted: tsModule.formatDiagnosticsWithColorAndContext(data, formatHost),
            category: diagnostic.category,
            code: diagnostic.code,
            type,
        };
        if (diagnostic.file && diagnostic.start !== undefined) {
            const { line, character } = diagnostic.file.getLineAndCharacterOfPosition(diagnostic.start);
            entry.fileLine = `${diagnostic.file.fileName}(${line + 1},${character + 1})`;
        }
        return entry;
    });
}
function printDiagnostics(context, diagnostics, pretty = true) {
    diagnostics.forEach((diagnostic) => {
        let print;
        let color;
        let category;
        switch (diagnostic.category) {
            case tsModule.DiagnosticCategory.Message:
                print = context.info;
                color = safeExports.white;
                category = "";
                break;
            case tsModule.DiagnosticCategory.Error:
                print = context.error;
                color = safeExports.red;
                category = "error";
                break;
            case tsModule.DiagnosticCategory.Warning:
            default:
                print = context.warn;
                color = safeExports.yellow;
                category = "warning";
                break;
        }
        const type = diagnostic.type + " ";
        if (pretty)
            return print.call(context, `${diagnostic.formatted}`);
        if (diagnostic.fileLine !== undefined)
            return print.call(context, `${diagnostic.fileLine}: ${type}${category} TS${diagnostic.code}: ${color(diagnostic.flatMessage)}`);
        return print.call(context, `${type}${category} TS${diagnostic.code}: ${color(diagnostic.flatMessage)}`);
    });
}

const { Graph, alg } = require('graphlib');
const objHash = require("object-hash");
function convertEmitOutput(output, references) {
    const out = { code: "", references };
    output.outputFiles.forEach((e) => {
        if (e.name.endsWith(".d.ts"))
            out.dts = e;
        else if (e.name.endsWith(".d.ts.map"))
            out.dtsmap = e;
        else if (e.name.endsWith(".map"))
            out.map = e.text;
        else
            out.code = e.text;
    });
    return out;
}
function getAllReferences(importer, snapshot, options) {
    if (!snapshot)
        return [];
    const info = tsModule.preProcessFile(snapshot.getText(0, snapshot.getLength()), true, true);
    return ___namespace.compact(info.referencedFiles.concat(info.importedFiles).map((reference) => {
        var _a;
        const resolved = tsModule.nodeModuleNameResolver(reference.fileName, importer, options, tsModule.sys);
        return (_a = resolved.resolvedModule) === null || _a === void 0 ? void 0 : _a.resolvedFileName;
    }));
}
class TsCache {
    constructor(noCache, hashIgnoreUnknown, host, cacheRoot, options, rollupConfig, rootFilenames, context) {
        this.noCache = noCache;
        this.host = host;
        this.cacheRoot = cacheRoot;
        this.options = options;
        this.rollupConfig = rollupConfig;
        this.context = context;
        this.cacheVersion = "9";
        this.cachePrefix = "rpt2_";
        this.ambientTypesDirty = false;
        this.hashOptions = { algorithm: "sha1", ignoreUnknown: false };
        this.dependencyTree = new Graph({ directed: true });
        this.dependencyTree.setDefaultNodeLabel((_node) => ({ dirty: false }));
        if (noCache) {
            this.clean();
            return;
        }
        this.hashOptions.ignoreUnknown = hashIgnoreUnknown;
        this.cacheDir = `${this.cacheRoot}/${this.cachePrefix}${objHash({
            version: this.cacheVersion,
            rootFilenames,
            options: this.options,
            rollupConfig: this.rollupConfig,
            tsVersion: tsModule.version,
        }, 
        // @ts-ignore
        this.hashOptions)}`;
        this.init();
        const automaticTypes = tsModule.getAutomaticTypeDirectiveNames(options, tsModule.sys)
            .map((entry) => tsModule.resolveTypeReferenceDirective(entry, undefined, options, tsModule.sys))
            .filter((entry) => { var _a; return (_a = entry.resolvedTypeReferenceDirective) === null || _a === void 0 ? void 0 : _a.resolvedFileName; })
            .map((entry) => entry.resolvedTypeReferenceDirective.resolvedFileName);
        this.ambientTypes = rootFilenames.filter(file => file.endsWith(".d.ts"))
            .concat(automaticTypes)
            .map((id) => ({ id, snapshot: this.host.getScriptSnapshot(id) }));
        this.checkAmbientTypes();
    }
    clean() {
        if (!fs__namespace.pathExistsSync(this.cacheRoot))
            return;
        const entries = fs__namespace.readdirSync(this.cacheRoot);
        entries.forEach((e) => {
            const dir = `${this.cacheRoot}/${e}`;
            /* istanbul ignore if -- this is a safety check, but shouldn't happen when using a dedicated cache dir */
            if (!e.startsWith(this.cachePrefix)) {
                this.context.debug(`skipping cleaning '${dir}' as it does not have prefix '${this.cachePrefix}'`);
                return;
            }
            /* istanbul ignore if -- this is a safety check, but should never happen in normal usage */
            if (!fs__namespace.statSync(dir).isDirectory) {
                this.context.debug(`skipping cleaning '${dir}' as it is not a directory`);
                return;
            }
            this.context.info(safeExports.blue(`cleaning cache: ${dir}`));
            fs__namespace.removeSync(`${dir}`);
        });
    }
    setDependency(importee, importer) {
        // importee -> importer
        this.context.debug(`${safeExports.blue("dependency")} '${importee}'`);
        this.context.debug(`    imported by '${importer}'`);
        this.dependencyTree.setEdge(importer, importee);
    }
    walkTree(cb) {
        if (alg.isAcyclic(this.dependencyTree))
            // @ts-ignore
            return alg.topsort(this.dependencyTree).forEach(id => cb(id));
        this.context.info(safeExports.yellow("import tree has cycles"));
        // @ts-ignore
        this.dependencyTree.nodes().forEach(id => cb(id));
    }
    done() {
        if (this.noCache)
            return;
        this.context.info(safeExports.blue("rolling caches"));
        this.codeCache.roll();
        this.semanticDiagnosticsCache.roll();
        this.syntacticDiagnosticsCache.roll();
        this.typesCache.roll();
    }
    getCompiled(id, snapshot, transform) {
        this.context.info(`${safeExports.blue("transpiling")} '${id}'`);
        // if !isolatedModules, compiled JS code can change if its imports do (e.g. enums). also, declarations can change based on imports as well
        return this.getCached(this.codeCache, id, snapshot, Boolean(!this.options.isolatedModules || this.options.declaration), transform);
    }
    getSyntacticDiagnostics(id, snapshot, check) {
        return this.getDiagnostics("syntax", this.syntacticDiagnosticsCache, id, snapshot, check);
    }
    getSemanticDiagnostics(id, snapshot, check) {
        return this.getDiagnostics("semantic", this.semanticDiagnosticsCache, id, snapshot, check);
    }
    checkAmbientTypes() {
        this.context.debug(safeExports.blue("Ambient types:"));
        const typeHashes = this.ambientTypes.filter((snapshot) => snapshot.snapshot !== undefined)
            .map((snapshot) => {
            this.context.debug(`    ${snapshot.id}`);
            return this.createHash(snapshot.id, snapshot.snapshot);
        });
        // types dirty if any d.ts changed, added or removed
        this.ambientTypesDirty = !this.typesCache.match(typeHashes);
        if (this.ambientTypesDirty)
            this.context.info(safeExports.yellow("ambient types changed, redoing all semantic diagnostics"));
        typeHashes.forEach(this.typesCache.touch, this.typesCache);
    }
    getDiagnostics(type, cache, id, snapshot, check) {
        // don't need to check imports for syntactic diagnostics (per https://github.com/microsoft/TypeScript/wiki/Using-the-Language-Service-API#design-goals)
        return this.getCached(cache, id, snapshot, type === "semantic", () => convertDiagnostic(type, check()));
    }
    getCached(cache, id, snapshot, checkImports, convert) {
        if (this.noCache)
            return convert();
        const hash = this.createHash(id, snapshot);
        this.context.debug(`    cache: '${cache.path(hash)}'`);
        if (cache.exists(hash) && !this.isDirty(id, checkImports)) {
            this.context.debug(safeExports.green("    cache hit"));
            const data = cache.read(hash);
            if (data) {
                cache.write(hash, data);
                return data;
            }
            else /* istanbul ignore next -- should only happen when corrupted cache */
                this.context.warn(safeExports.yellow("    cache broken, discarding"));
        }
        this.context.debug(safeExports.yellow("    cache miss"));
        const convertedData = convert();
        cache.write(hash, convertedData);
        this.markAsDirty(id);
        return convertedData;
    }
    init() {
        this.codeCache = new RollingCache(`${this.cacheDir}/code`);
        this.typesCache = new RollingCache(`${this.cacheDir}/types`);
        this.syntacticDiagnosticsCache = new RollingCache(`${this.cacheDir}/syntacticDiagnostics`);
        this.semanticDiagnosticsCache = new RollingCache(`${this.cacheDir}/semanticDiagnostics`);
    }
    markAsDirty(id) {
        this.dependencyTree.setNode(id, { dirty: true });
    }
    /** @returns true if node, any of its imports, or any ambient types changed */
    isDirty(id, checkImports) {
        const label = this.dependencyTree.node(id);
        if (!label)
            return false;
        if (!checkImports || label.dirty)
            return label.dirty;
        if (this.ambientTypesDirty)
            return true;
        const dependencies = alg.dijkstra(this.dependencyTree, id);
        return Object.keys(dependencies).some(node => {
            const dependency = dependencies[node];
            if (!node || dependency.distance === Infinity)
                return false;
            const l = this.dependencyTree.node(node);
            const dirty = l === undefined ? true : l.dirty;
            if (dirty)
                this.context.debug(`    import changed: ${node}`);
            return dirty;
        });
    }
    /** @returns an FS-safe hash string for use as a path to the cached content */
    createHash(id, snapshot) {
        const data = snapshot.getText(0, snapshot.getLength());
        // @ts-ignore
        return objHash({ data, id }, this.hashOptions);
    }
}

function getOptionsOverrides({ useTsconfigDeclarationDir, cacheRoot }, preParsedTsconfig) {
    const overrides = {
        noEmitHelpers: false,
        importHelpers: true,
        noResolve: false,
        noEmit: false,
        noEmitOnError: false,
        inlineSourceMap: false,
        outDir: pluginutils.normalizePath(`${cacheRoot}/placeholder`),
        moduleResolution: tsModule.ModuleResolutionKind.NodeJs,
        allowNonTsExtensions: true,
    };
    if (!preParsedTsconfig)
        return overrides;
    if (preParsedTsconfig.options.module === undefined)
        overrides.module = tsModule.ModuleKind.ES2015;
    // only set declarationDir if useTsconfigDeclarationDir is enabled
    if (!useTsconfigDeclarationDir)
        overrides.declarationDir = undefined;
    // unsetting sourceRoot if sourceMap is not enabled (in case original tsconfig had inlineSourceMap set that is being unset and would cause TS5051)
    const sourceMap = preParsedTsconfig.options.sourceMap;
    if (!sourceMap)
        overrides.sourceRoot = undefined;
    return overrides;
}
function expandIncludeWithDirs(include, dirs) {
    const newDirs = [];
    dirs.forEach(root => {
        if (include instanceof Array)
            include.forEach(x => newDirs.push(pluginutils.normalizePath(path__namespace.join(root, x))));
        else
            newDirs.push(pluginutils.normalizePath(path__namespace.join(root, include)));
    });
    return newDirs;
}
function createFilter(context, pluginOptions, parsedConfig) {
    let included = pluginOptions.include;
    let excluded = pluginOptions.exclude;
    if (parsedConfig.options.rootDirs) {
        included = expandIncludeWithDirs(included, parsedConfig.options.rootDirs);
        excluded = expandIncludeWithDirs(excluded, parsedConfig.options.rootDirs);
    }
    if (parsedConfig.projectReferences) {
        included = expandIncludeWithDirs(included, parsedConfig.projectReferences.map((x) => x.path)).concat(included);
        excluded = expandIncludeWithDirs(excluded, parsedConfig.projectReferences.map((x) => x.path)).concat(excluded);
    }
    context.debug(() => `included:\n${JSON.stringify(included, undefined, 4)}`);
    context.debug(() => `excluded:\n${JSON.stringify(excluded, undefined, 4)}`);
    return pluginutils.createFilter(included, excluded, { resolve: parsedConfig.options.rootDir });
}

function parseTsConfig(context, pluginOptions) {
    var _a, _b;
    const fileName = tsModule.findConfigFile(pluginOptions.cwd, tsModule.sys.fileExists, pluginOptions.tsconfig);
    // if the value was provided, but no file, fail hard
    if (pluginOptions.tsconfig !== undefined && !fileName)
        context.error(`failed to open '${pluginOptions.tsconfig}'`);
    let loadedConfig = {};
    let baseDir = pluginOptions.cwd;
    let configFileName;
    let pretty = true;
    if (fileName) {
        const text = tsModule.sys.readFile(fileName); // readFile only returns undefined when the file doesn't exist, which we already checked above
        const result = tsModule.parseConfigFileTextToJson(fileName, text);
        pretty = (_b = (_a = result.config) === null || _a === void 0 ? void 0 : _a.pretty) !== null && _b !== void 0 ? _b : pretty;
        if (result.error !== undefined) {
            printDiagnostics(context, convertDiagnostic("config", [result.error]), pretty);
            context.error(`failed to parse '${fileName}'`);
        }
        loadedConfig = result.config;
        baseDir = path.dirname(fileName);
        configFileName = fileName;
    }
    const mergedConfig = {};
    ___namespace.merge(mergedConfig, pluginOptions.tsconfigDefaults, loadedConfig, pluginOptions.tsconfigOverride);
    const preParsedTsConfig = tsModule.parseJsonConfigFileContent(mergedConfig, tsModule.sys, baseDir, getOptionsOverrides(pluginOptions), configFileName);
    const compilerOptionsOverride = getOptionsOverrides(pluginOptions, preParsedTsConfig);
    const parsedTsConfig = tsModule.parseJsonConfigFileContent(mergedConfig, tsModule.sys, baseDir, compilerOptionsOverride, configFileName);
    const module = parsedTsConfig.options.module;
    if (module !== tsModule.ModuleKind.ES2015 && module !== tsModule.ModuleKind.ES2020 && module !== tsModule.ModuleKind.ESNext)
        context.error(`Incompatible tsconfig option. Module resolves to '${tsModule.ModuleKind[module]}'. This is incompatible with Rollup, please use 'module: "ES2015"', 'module: "ES2020"', or 'module: "ESNext"'.`);
    printDiagnostics(context, convertDiagnostic("config", parsedTsConfig.errors), pretty);
    context.debug(`built-in options overrides: ${JSON.stringify(compilerOptionsOverride, undefined, 4)}`);
    context.debug(`parsed tsconfig: ${JSON.stringify(parsedTsConfig, undefined, 4)}`);
    return { parsedTsConfig, fileName };
}

// The injected id for helpers.
const TSLIB = "tslib";
const TSLIB_VIRTUAL = "\0tslib.js";
let tslibSource;
let tslibVersion;
try {
    // tslint:disable-next-line:no-string-literal no-var-requires
    const tslibPackage = require("tslib/package.json");
    const tslibPath = require.resolve("tslib/" + tslibPackage.module);
    tslibSource = fs$1.readFileSync(tslibPath, "utf8");
    tslibVersion = tslibPackage.version;
}
catch (e) {
    console.warn("rpt2: Error loading `tslib` helper library.");
    throw e;
}

const findCacheDir = require("find-cache-dir");
// these use globals during testing and are substituted by rollup-plugin-re during builds
const RPT2_VERSION = (global === null || global === void 0 ? void 0 : global.rpt2__ROLLUP_VERSION_RANGE) || "$RPT2_VERSION";
const typescript = (options) => {
    let watchMode = false;
    let supportsThisLoad = false;
    let generateRound = 0;
    let rollupOptions;
    let context;
    let filter;
    let parsedConfig;
    let tsConfigPath;
    let servicesHost;
    let service;
    let documentRegistry; // keep the same DocumentRegistry between watch cycles
    let cache;
    let noErrors = true;
    let transformedFiles;
    const declarations = {};
    const checkedFiles = new Set();
    const getDiagnostics = (id, snapshot) => {
        return cache.getSyntacticDiagnostics(id, snapshot, () => {
            return service.getSyntacticDiagnostics(id);
        }).concat(cache.getSemanticDiagnostics(id, snapshot, () => {
            return service.getSemanticDiagnostics(id);
        }));
    };
    const typecheckFile = (id, snapshot, tcContext) => {
        if (!snapshot)
            return;
        id = pluginutils.normalizePath(id);
        checkedFiles.add(id); // must come before print, as that could bail
        const diagnostics = getDiagnostics(id, snapshot);
        printDiagnostics(tcContext, diagnostics, parsedConfig.options.pretty !== false);
        if (diagnostics.length > 0)
            noErrors = false;
    };
    const addDeclaration = (id, result) => {
        if (!result.dts)
            return;
        const key = pluginutils.normalizePath(id);
        declarations[key] = { type: result.dts, map: result.dtsmap };
        context.debug(() => `${safeExports.blue("generated declarations")} for '${key}'`);
    };
    /** to be called at the end of Rollup's build phase, before output generation */
    const buildDone = () => {
        if (!watchMode && !noErrors)
            context.info(safeExports.yellow("there were errors or warnings."));
        cache === null || cache === void 0 ? void 0 : cache.done(); // if there's an initialization error in `buildStart`, such as a `tsconfig` error, the cache may not exist yet
    };
    const pluginOptions = Object.assign({}, {
        check: true,
        verbosity: VerbosityLevel.Warning,
        clean: false,
        cacheRoot: findCacheDir({ name: "rollup-plugin-typescript2" }),
        include: ["*.ts+(|x)", "**/*.ts+(|x)"],
        exclude: ["*.d.ts", "**/*.d.ts"],
        abortOnError: true,
        rollupCommonJSResolveHack: false,
        tsconfig: undefined,
        useTsconfigDeclarationDir: false,
        tsconfigOverride: {},
        transformers: [],
        tsconfigDefaults: {},
        objectHashIgnoreUnknownHack: false,
        cwd: process.cwd(),
    }, options);
    if (!pluginOptions.typescript) {
        pluginOptions.typescript = require("typescript");
    }
    setTypescriptModule(pluginOptions.typescript);
    documentRegistry = tsModule.createDocumentRegistry();
    const self = {
        name: "rpt2",
        options(config) {
            rollupOptions = Object.assign({}, config);
            return config;
        },
        buildStart() {
            context = new RollupContext(pluginOptions.verbosity, pluginOptions.abortOnError, this, "rpt2: ");
            watchMode = process.env.ROLLUP_WATCH === "true" || !!this.meta.watchMode; // meta.watchMode was added in 2.14.0 to capture watch via Rollup API (i.e. no env var) (c.f. https://github.com/rollup/rollup/blob/master/CHANGELOG.md#2140)
            ({ parsedTsConfig: parsedConfig, fileName: tsConfigPath } = parseTsConfig(context, pluginOptions));
            // print out all versions and configurations
            context.info(`typescript version: ${tsModule.version}`);
            context.info(`tslib version: ${tslibVersion}`);
            context.info(`rollup version: ${this.meta.rollupVersion}`);
            supportsThisLoad = semver.satisfies(this.meta.rollupVersion, ">=2.60.0", { includePrerelease: true }); // this.load is 2.60.0+ only (c.f. https://github.com/rollup/rollup/blob/master/CHANGELOG.md#2600)
            if (!supportsThisLoad)
                context.warn(() => `${safeExports.yellow("You are using a Rollup version '<2.60.0'")}. This may result in type-only files being ignored.`);
            context.info(`rollup-plugin-typescript2 version: ${RPT2_VERSION}`);
            context.debug(() => `plugin options:\n${JSON.stringify(pluginOptions, (key, value) => key === "typescript" ? `version ${value.version}` : value, 4)}`);
            context.debug(() => `rollup config:\n${JSON.stringify(rollupOptions, undefined, 4)}`);
            context.debug(() => `tsconfig path: ${tsConfigPath}`);
            if (pluginOptions.objectHashIgnoreUnknownHack)
                context.warn(() => `${safeExports.yellow("You are using 'objectHashIgnoreUnknownHack' option")}. If you enabled it because of async functions, try disabling it now.`);
            if (pluginOptions.rollupCommonJSResolveHack)
                context.warn(() => `${safeExports.yellow("You are using 'rollupCommonJSResolveHack' option")}. This is no longer needed, try disabling it now.`);
            if (watchMode)
                context.info(`running in watch mode`);
            filter = createFilter(context, pluginOptions, parsedConfig);
            servicesHost = new LanguageServiceHost(parsedConfig, pluginOptions.transformers, pluginOptions.cwd);
            service = tsModule.createLanguageService(servicesHost, documentRegistry);
            servicesHost.setLanguageService(service);
            cache = new TsCache(pluginOptions.clean, pluginOptions.objectHashIgnoreUnknownHack, servicesHost, pluginOptions.cacheRoot, parsedConfig.options, rollupOptions, parsedConfig.fileNames, context);
            // reset transformedFiles Set on each watch cycle
            transformedFiles = new Set();
            // printing compiler option errors
            if (pluginOptions.check) {
                const diagnostics = convertDiagnostic("options", service.getCompilerOptionsDiagnostics());
                printDiagnostics(context, diagnostics, parsedConfig.options.pretty !== false);
                if (diagnostics.length > 0)
                    noErrors = false;
            }
        },
        watchChange(id) {
            const key = pluginutils.normalizePath(id);
            delete declarations[key];
            checkedFiles.delete(key);
        },
        resolveId(importee, importer) {
            var _a;
            if (importee === TSLIB)
                return TSLIB_VIRTUAL;
            if (!importer)
                return;
            importer = pluginutils.normalizePath(importer);
            // TODO: use module resolution cache
            const result = tsModule.nodeModuleNameResolver(importee, importer, parsedConfig.options, tsModule.sys);
            const resolved = (_a = result.resolvedModule) === null || _a === void 0 ? void 0 : _a.resolvedFileName;
            if (!resolved)
                return;
            if (resolved.endsWith(".d.ts"))
                return;
            if (!filter(resolved))
                return;
            cache.setDependency(resolved, importer);
            context.debug(() => `${safeExports.blue("resolving")} '${importee}' imported by '${importer}'`);
            context.debug(() => `    to '${resolved}'`);
            return path.normalize(resolved); // use host OS separators to fix Windows issue: https://github.com/ezolenko/rollup-plugin-typescript2/pull/251
        },
        load(id) {
            if (id === TSLIB_VIRTUAL)
                return tslibSource;
            return null;
        },
        transform(code, id) {
            var _a;
            return __awaiter(this, void 0, void 0, function* () {
                transformedFiles.add(id); // note: this does not need normalization as we only compare Rollup <-> Rollup, and not Rollup <-> TS
                if (!filter(id))
                    return undefined;
                const snapshot = servicesHost.setSnapshot(id, code);
                // getting compiled file from cache or from ts
                const result = cache.getCompiled(id, snapshot, () => {
                    const output = service.getEmitOutput(id);
                    if (output.emitSkipped) {
                        noErrors = false;
                        // always checking on fatal errors, even if options.check is set to false
                        typecheckFile(id, snapshot, context);
                        // since no output was generated, aborting compilation
                        this.error(safeExports.red(`Emit skipped for '${id}'. See https://github.com/microsoft/TypeScript/issues/49790 for potential reasons why this may occur`));
                    }
                    const references = getAllReferences(id, snapshot, parsedConfig.options);
                    return convertEmitOutput(output, references);
                });
                if (pluginOptions.check)
                    typecheckFile(id, snapshot, context);
                if (!result)
                    return undefined;
                if (watchMode && result.references) {
                    if (tsConfigPath)
                        this.addWatchFile(tsConfigPath);
                    result.references.map(this.addWatchFile, this);
                    context.debug(() => `${safeExports.green("    watching")}: ${result.references.join("\nrpt2:               ")}`);
                }
                addDeclaration(id, result);
                // handle all type-only imports by resolving + loading all of TS's references
                // Rollup can't see these otherwise, because they are "emit-less" and produce no JS
                if (result.references && supportsThisLoad) {
                    for (const ref of result.references) {
                        if (ref.endsWith(".d.ts"))
                            continue;
                        const module = yield this.resolve(ref, id);
                        if (!module || transformedFiles.has(module.id)) // check for circular references (per https://rollupjs.org/guide/en/#thisload)
                            continue;
                        // wait for all to be loaded (otherwise, as this is async, some may end up only loading after `generateBundle`)
                        yield this.load({ id: module.id });
                    }
                }
                // if a user sets this compilerOption, they probably want another plugin (e.g. Babel, ESBuild) to transform their TS instead, while rpt2 just type-checks and/or outputs declarations
                // note that result.code is non-existent if emitDeclarationOnly per https://github.com/ezolenko/rollup-plugin-typescript2/issues/268
                if (parsedConfig.options.emitDeclarationOnly) {
                    context.debug(() => `${safeExports.blue("emitDeclarationOnly")} enabled, not transforming TS`);
                    return undefined;
                }
                const transformResult = { code: result.code, map: { mappings: "" } };
                if (result.map) {
                    (_a = pluginOptions.sourceMapCallback) === null || _a === void 0 ? void 0 : _a.call(pluginOptions, id, result.map);
                    transformResult.map = JSON.parse(result.map);
                }
                return transformResult;
            });
        },
        buildEnd(err) {
            var _a;
            generateRound = 0; // in watch mode, buildEnd resets generate count just before generateBundle for each output
            if (err) {
                buildDone();
                // workaround: err.stack contains err.message and Rollup prints both, causing duplication, so split out the stack itself if it exists (c.f. https://github.com/ezolenko/rollup-plugin-typescript2/issues/103#issuecomment-1172820658)
                const stackOnly = (_a = err.stack) === null || _a === void 0 ? void 0 : _a.split(err.message)[1];
                if (stackOnly)
                    this.error(Object.assign(Object.assign({}, err), { message: err.message, stack: stackOnly }));
                else
                    this.error(err);
            }
            if (!pluginOptions.check)
                return buildDone();
            // walkTree once on each cycle when in watch mode
            if (watchMode) {
                cache.walkTree((id) => {
                    if (!filter(id))
                        return;
                    const snapshot = servicesHost.getScriptSnapshot(id);
                    typecheckFile(id, snapshot, context);
                });
            }
            // type-check missed files as well
            parsedConfig.fileNames.forEach((name) => {
                const key = pluginutils.normalizePath(name);
                if (checkedFiles.has(key) || !filter(key)) // don't duplicate if it's already been checked
                    return;
                context.debug(() => `type-checking missed '${key}'`);
                const snapshot = servicesHost.getScriptSnapshot(key);
                typecheckFile(key, snapshot, context);
            });
            buildDone();
        },
        generateBundle(_output) {
            context.debug(() => `generating target ${generateRound + 1}`);
            generateRound++;
            if (!parsedConfig.options.declaration)
                return;
            parsedConfig.fileNames.forEach((name) => {
                const key = pluginutils.normalizePath(name);
                if (key in declarations || !filter(key))
                    return;
                context.debug(() => `generating missed declarations for '${key}'`);
                const out = convertEmitOutput(service.getEmitOutput(key, true));
                addDeclaration(key, out);
            });
            const emitDeclaration = (key, extension, entry) => {
                if (!entry)
                    return;
                let fileName = entry.name;
                if (fileName.includes("?")) // HACK for rollup-plugin-vue, it creates virtual modules in form 'file.vue?rollup-plugin-vue=script.ts'
                    fileName = fileName.split("?", 1) + extension;
                // If 'useTsconfigDeclarationDir' is in plugin options, directly write to 'declarationDir'.
                // This may not be under Rollup's output directory, and thus can't be emitted as an asset.
                if (pluginOptions.useTsconfigDeclarationDir) {
                    context.debug(() => `${safeExports.blue("emitting declarations")} for '${key}' to '${fileName}'`);
                    tsModule.sys.writeFile(fileName, entry.text, entry.writeByteOrderMark);
                    return;
                }
                // don't mutate the entry because generateBundle gets called multiple times
                let entryText = entry.text;
                const cachePlaceholder = `${pluginOptions.cacheRoot}/placeholder`;
                // modify declaration map sources to correct relative path (only if outputting)
                if (extension === ".d.ts.map" && ((_output === null || _output === void 0 ? void 0 : _output.file) || (_output === null || _output === void 0 ? void 0 : _output.dir))) {
                    const declarationDir = (_output.file ? path.dirname(_output.file) : _output.dir);
                    const parsedText = JSON.parse(entryText);
                    // invert back to absolute, then make relative to declarationDir
                    parsedText.sources = parsedText.sources.map(source => {
                        const absolutePath = path.resolve(cachePlaceholder, source);
                        return pluginutils.normalizePath(path.relative(declarationDir, absolutePath));
                    });
                    entryText = JSON.stringify(parsedText);
                }
                const relativePath = pluginutils.normalizePath(path.relative(cachePlaceholder, fileName));
                context.debug(() => `${safeExports.blue("emitting declarations")} for '${key}' to '${relativePath}'`);
                this.emitFile({
                    type: "asset",
                    source: entryText,
                    fileName: relativePath,
                });
            };
            Object.keys(declarations).forEach((key) => {
                const { type, map } = declarations[key];
                emitDeclaration(key, ".d.ts", type);
                emitDeclaration(key, ".d.ts.map", map);
            });
        },
    };
    return self;
};

module.exports = typescript;
//# sourceMappingURL=rollup-plugin-typescript2.cjs.js.map
